<template>
  <v-container>
    <v-breadcrumbs class="px-0" :items="items"></v-breadcrumbs>

    <v-row no-gutters class="d-flex align-center">
      <h1>Nova Demanda</h1>
      <v-spacer></v-spacer>
      <v-btn depressed small color="warning" to="/demands/">VOLTAR</v-btn>
    </v-row>
    <v-divider></v-divider>
    <div id="customers">
      <p>Preencha o formulário:</p>

      <v-form v-model="valid">
        <v-container>
          <v-row>
            <v-col cols="12" md="6">
              <v-text-field
                v-model="demand.description"
                :rules="descriptionRules"
                label="Descrição"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="demand.category" label="Categoria" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="demand.attachments" label="Anexar documento" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="demand.customer_id" label="Cliente" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="demand.status" label="Status" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="demand.employee_id" label="Funcionário responsável" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="demand.value" :rules="valueRules" label="Valor" required></v-text-field>
            </v-col>

            <v-col cols="12" md="3">
              <v-text-field v-model="demand.start_date" label="Data de inicio" required></v-text-field>
            </v-col>

            <v-col cols="12" md="3">
              <v-text-field v-model="demand.end_date" label="Data de termino" required></v-text-field>
            </v-col>
          </v-row>
        </v-container>
        <v-btn depressed color="success" @click="salvar">SALVAR</v-btn>
      </v-form>
      <v-row>
        <v-spacer></v-spacer>
      </v-row>
    </div>
  </v-container>
</template>

<script>
import axios from "axios";
import { mask } from "vue-the-mask";
export default {
  directives: { mask },
  data: () => ({
    maskDate: "##/##/####",
    valid: false,
    demand: {
      description: "",
      customer_id: "",
      attachments: "",
      employee_id: "",
      category: "",
      status: "",
      value: "",
      start_date: "",
      end_date: ""
    },
    edit: false,
    descriptionRules: [v => !!v || "Descrição é obrigatório"],
    valueRules: [],
    items: [
      {
        text: "Dashboard",
        disabled: false,
        to: "/"
      },
      {
        text: "Demandas",
        disabled: false,
        exact: true,
        to: "/demands"
      },
      {
        text: "Cadastrar demanda",
        disabled: true
      }
    ]
  }),
  methods: {
    salvar() {
      if (this.edit == false) {
        console.log("salvar");
        console.log(this.demand);
        axios
          .post("https://young-forest-65938.herokuapp.com/api/v1/demands", {
            description: this.demand.description,
            attachments: this.demand.attachments,
            value: this.demand.value,
            start_date: this.demand.start_date,
            end_date: this.demand.end_date,
            status: this.demand.status,
            customer_id: this.demand.customer_id,
            employee_id: this.demand.employee_id,
            category: this.demand.category
          })
          .then(function(response) {
            console.log(this.demand);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/demands");
      } else {
        console.log("editar else");
        axios
          .put(
            `https://young-forest-65938.herokuapp.com/api/v1/demands${this.$router.currentRoute.query.id}`,
            {
              description: this.demand.description,
              attachments: this.demand.attachments,
              value: this.demand.value,
              start_date: this.demand.start_date,
              end_date: this.demand.end_date,
              status: this.demand.status,
              customer_id: this.demand.customer_id,
              employee_id: this.demand.employee_id,
              category: this.demand.category
            }
          )
          .then(function(response) {
            console.log(this.demand);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/demands");
      }
    }
  },
  mounted() {
    console.log(this.$router.currentRoute.query.id);
    if (this.$router.currentRoute.query.id != null) {
      this.edit = true;
      console.log(this.$router.currentRoute.query.id);
      console.log("if mounted");
      return axios
        .get(
          `https://young-forest-65938.herokuapp.com/api/v1/demands/${this.$router.currentRoute.query.id}`
        )
        .then(response => {
          var resp = response.data;
          this.demand = resp.data;
          console.log(this.demand);
        });
    }
  }
};
</script>
